//! `SeaORM` Entity. Generated by sea-orm-codegen 0.11.2

use rand::{rngs::OsRng, RngCore};
use scrypt::{scrypt, Params};
use sea_orm::{entity::prelude::*, ActiveValue::Set};

#[derive(Clone, Debug, PartialEq, DeriveEntityModel, Eq)]
#[sea_orm(table_name = "master_pass")]
pub struct Model {
    #[sea_orm(primary_key, auto_increment = false)]
    pub user_id: u64,
    #[sea_orm(column_type = "Binary(BlobSize::Blob(Some(64)))")]
    pub salt: Vec<u8>,
    #[sea_orm(column_type = "Binary(BlobSize::Blob(Some(64)))")]
    pub password_hash: Vec<u8>,
}

#[derive(Copy, Clone, Debug, EnumIter, DeriveRelation)]
pub enum Relation {}

impl ActiveModelBehavior for ActiveModel {}

impl ActiveModel {
    pub fn from_unencrypted(user_id: u64, password: &str) -> crate::Result<Self> {
        let mut salt = vec![0; 64];
        OsRng.fill_bytes(&mut salt);
        let params = Params::new(
            Params::RECOMMENDED_LOG_N,
            Params::RECOMMENDED_R,
            Params::RECOMMENDED_P,
            64,
        )?;
        let mut password_hash = vec![0; 64];
        scrypt(password.as_ref(), &salt, &params, &mut password_hash)?;
        Ok(Self {
            user_id: Set(user_id),
            salt: Set(salt),
            password_hash: Set(password_hash),
        })
    }
}
